# Generated by Django 3.1 on 2020-09-11 07:26

import django.db.models.deletion
from django.db import migrations, models

import arkindex.dataimport.models


def copy_repository_corpus(apps, schema_editor):
    Corpus = apps.get_model('documents', 'Corpus')
    for corpus in Corpus.objects.all():
        repos = list(corpus.repos.filter(type=arkindex.dataimport.models.RepositoryType.IIIF))
        if len(repos) == 0:
            continue
        elif len(repos) == 1:
            corpus.repository = repos[0]
        else:
            raise Exception(f'"{corpus.name}" corpus is referenced by multiple IIIF repositories: {[r.url for r in repos]}')
        corpus.save()


class Migration(migrations.Migration):

    dependencies = [
        ('dataimport', '0019_repository_type'),
        ('documents', '0018_worker_version_attributes'),
    ]

    operations = [
        migrations.AddField(
            model_name='corpus',
            name='repository',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='corpora', to='dataimport.repository'),
        ),
        migrations.RunPython(
            copy_repository_corpus,
            reverse_code=migrations.RunPython.noop,
            elidable=True
        )
    ]
